      SUBROUTINE PZHEEV4( UPLO, N, A, IA, JA, DESCA, VL, VU,
     $                    ABSTOL, M, NZ, W, ORFAC, Z, IZ, JZ, DESCZ,
     $                    WORK, LWORK, RWORK, LRWORK, IWORK,
     $                    LIWORK, IFAIL, ICLUSTR, GAP, INFO )
*
* Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            IA, INFO, IZ, JA, JZ, LIWORK, LRWORK,
     $                   LWORK, M, N, NZ
      DOUBLE PRECISION   ABSTOL, ORFAC, VL, VU
*
* Array Arguments ..
      INTEGER            DESCA( * ), DESCZ( * ), ICLUSTR( * ),
     $                   IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   GAP( * ), RWORK( * ), W( * )
      COMPLEX*16         A( * ), WORK( * ), Z( * )
*
* Parameters ..
      INTEGER            CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_
      PARAMETER          ( CTXT_ = 2, M_ = 3, N_ = 4,
     $                   MB_ = 5, NB_ = 6, RSRC_ = 7, CSRC_ = 8 )
      DOUBLE PRECISION   ZERO, ONE, TEN, FIVE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0,
     $                   TEN = 10.0D+0, FIVE = 5.0D+0 )
      INTEGER            IERREIN, IERRCLS, IERRSPC, IERREBZ
      PARAMETER          ( IERREIN = 1, IERRCLS = 2, IERRSPC = 4,
     $                   IERREBZ = 8 )
*
* Local Scalars ..
      LOGICAL            LOWER, LQUERY, QUICKRETURN
      CHARACTER          ORDER
      INTEGER            ANB, CSRC_A, I, IAROW, ICOFFA, ICTXT, IINFO,
     $                   INDD, INDD2, INDE, INDE2, INDIBL, INDISP,
     $                   INDRWORK, INDTAU, INDWORK, IROFFA, IROFFZ,
     $                   ISCALE, ISIZESTEBZ, ISIZESTEIN, IZROW,
     $                   LALLWORK, LIWMIN, LLRWORK, LLWORK, LRWMIN,
     $                   LRWOPT, LWMIN, LWOPT, MAXEIGS, MB_A, MQ0,
     $                   MYCOL, MYROW, NB, NB_A, NEIG, NHETRD_LWOPT, NN,
     $                   NNP, NP0, NPCOL, NPROCS, NPROW, NPS, NQ0,
     $                   NSPLIT, NZZ, OFFSET, RSRC_A, RSRC_Z, SIZEHEEVX,
     $                   SIZESTEIN, SQNPC
      DOUBLE PRECISION   ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM, VLL, VUU
*
* Local Arrays ..
      INTEGER            IDUM1( 2 ), IDUM2( 2 )
*
* External Functions ..
      LOGICAL            LSAME
      INTEGER            ICEIL, INDXG2P, NUMROC, PJLAENV
      DOUBLE PRECISION   PDLAMCH, PZLANHE
      EXTERNAL           LSAME, ICEIL, INDXG2P, NUMROC, PJLAENV,
     $                   PDLAMCH, PZLANHE
*
* External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DGEBR2D, DGEBS2D,
     $                   DLASRT, DSCAL, IGAMN2D, PCHK2MAT,
     $                   PDLARED1D, PDSTEBZ, PXERBLA, PZELGET, PZHENTRD,
     $                   PZLASCL, PZSTEIN, PZUNMTR
*
* Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, ICHAR, INT, MAX, MIN, MOD,
     $                   SQRT
*
* Executable Statements ..
*
      QUICKRETURN = ( N.EQ.0 )
*
* Test the input arguments.
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
*
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      ELSE
         IF( ICTXT.NE.DESCZ( CTXT_ ) ) THEN
            INFO = -( 1700+CTXT_ )
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, INFO )
         CALL CHK1MAT( N, 2, N, 2, IZ, JZ, DESCZ, 17, INFO )
*
         IF( INFO.EQ.0 ) THEN
*
* Get machine constants.
*
            SAFMIN = PDLAMCH( ICTXT, 'Safe minimum' )
            EPS = PDLAMCH( ICTXT, 'Precision' )
            SMLNUM = SAFMIN / EPS
            BIGNUM = ONE / SMLNUM
            RMIN = SQRT( SMLNUM )
            RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
            NPROCS = NPROW*NPCOL
            LOWER = LSAME( UPLO, 'L' )
*
* Set up pointers into the WORK array
*
            INDTAU = 1
            INDWORK = INDTAU + N
            LLWORK = LWORK - INDWORK + 1
*
* Set up pointers into the RWORK array
*
            INDE = 1
            INDD = INDE + N
            INDD2 = INDD + N
            INDE2 = INDD2 + N
            INDRWORK = INDE2 + N
            LLRWORK = LRWORK - INDRWORK + 1
*
* Set up pointers into the IWORK array
*
            ISIZESTEIN = 3*N + NPROCS + 1
            ISIZESTEBZ = MAX( 4*N, 14, NPROCS )
            INDIBL = ( MAX( ISIZESTEIN, ISIZESTEBZ ) ) + 1
            INDISP = INDIBL + N
*
* Compute the total amount of space needed
*
            LQUERY = .FALSE.
            IF( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 .OR. LRWORK.EQ.-1 )
     $         LQUERY = .TRUE.
*
            NNP = MAX( N, NPROCS+1, 4 )
            LIWMIN = 6*NNP
*
            NPROCS = NPROW*NPCOL
            NB_A = DESCA( NB_ )
            MB_A = DESCA( MB_ )
            NB = NB_A
            NN = MAX( N, NB, 2 )
*
            RSRC_A = DESCA( RSRC_ )
            CSRC_A = DESCA( CSRC_ )
            IROFFA = MOD( IA-1, MB_A )
            ICOFFA = MOD( JA-1, NB_A )
            IAROW = INDXG2P( 1, NB_A, MYROW, RSRC_A, NPROW )
            NP0 = NUMROC( N+IROFFA, NB, 0, 0, NPROW )
            MQ0 = NUMROC( N+ICOFFA, NB, 0, 0, NPCOL )
               RSRC_Z = DESCZ( RSRC_ )
               IROFFZ = MOD( IZ-1, MB_A )
               IZROW = INDXG2P( 1, NB_A, MYROW, RSRC_Z, NPROW )
*
            IF( .NOT.LQUERY ) THEN
               LWMIN = N + MAX( NB*( NP0+1 ), 3 )
               LWOPT = LWMIN
               LRWMIN = 5*NN + 4*N
                  MQ0 = NUMROC( MAX( N, NB, 2 ), NB, 0, 0, NPCOL )
                  LRWOPT = 4*N + MAX( 5*NN, NP0*MQ0 ) +
     $                     ICEIL( N, NPROW*NPCOL )*NN
               NEIG = 0
            ELSE
                NEIG = N
               MQ0 = NUMROC( MAX( NEIG, NB, 2 ), NB, 0, 0, NPCOL )
               NQ0 = NUMROC( NN, NB, 0, 0, NPCOL )
               LWMIN = N + ( NP0+NQ0+NB )*NB
               LRWMIN = 4*N + MAX( 5*NN, NP0*MQ0 ) +
     $                  ICEIL( NEIG, NPROW*NPCOL )*NN
               LRWOPT = LRWMIN
               LWOPT = LWMIN
*
            END IF
*
* Compute how much workspace is needed to use the new TRD code
*
            ANB = PJLAENV( ICTXT, 3, 'PZHETTRD', 'L', 0, 0, 0, 0 )
            SQNPC = INT( SQRT( DBLE( NPROW*NPCOL ) ) )
            NPS = MAX( NUMROC( N, 1, 0, 0, SQNPC ), 2*ANB )
            NHETRD_LWOPT = 2*( ANB+1 )*( 4*NPS+2 ) + ( NPS+2 )*NPS
            LWOPT = MAX( LWOPT, N+NHETRD_LWOPT )
*
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
               RWORK( 1 ) = ABSTOL
               RWORK( 2 ) = VL
               RWORK( 3 ) = VU
*
               CALL DGEBS2D( ICTXT, 'ALL', ' ', 3, 1, RWORK, 3 )
            ELSE
               CALL DGEBR2D( ICTXT, 'ALL', ' ', 3, 1, RWORK, 3, 0, 0 )
            END IF
*
            IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
               INFO = -1
            ELSE IF(.TRUE. .AND. N.GT.0 .AND. VU.LE.VL ) THEN
               INFO = -8
            ELSE IF( LWORK.LT.LWMIN .AND. LWORK.NE.-1 ) THEN
               INFO = -19
            ELSE IF( LRWORK.LT.LRWMIN .AND. LRWORK.NE.-1 ) THEN
               INFO = -21
            ELSE IF( LIWORK.LT.LIWMIN .AND. LIWORK.NE.-1 ) THEN
               INFO = -23
            ELSE IF( ( ABS( RWORK( 2 )-VL ).GT.FIVE*EPS*
     $               ABS( VL ) ) ) THEN
               INFO = -7
***
            ELSE IF( ( ABS( RWORK( 3 )-VU ).GT.FIVE*EPS*
     $               ABS( VU ) ) ) THEN
               INFO = -8
            ELSE IF( ABS( RWORK( 1 )-ABSTOL ).GT.FIVE*EPS*
     $               ABS( ABSTOL ) ) THEN
               INFO = -9
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -4
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -( 600+NB_ )
            END IF
               IF( IROFFA.NE.IROFFZ ) THEN
                  INFO = -15
               ELSE IF( IAROW.NE.IZROW ) THEN
                  INFO = -15
               ELSE IF( DESCA( M_ ).NE.DESCZ( M_ ) ) THEN
                  INFO = -( 1700+M_ )
               ELSE IF( DESCA( N_ ).NE.DESCZ( N_ ) ) THEN
                  INFO = -( 1700+N_ )
               ELSE IF( DESCA( MB_ ).NE.DESCZ( MB_ ) ) THEN
                  INFO = -( 1700+MB_ )
               ELSE IF( DESCA( NB_ ).NE.DESCZ( NB_ ) ) THEN
                  INFO = -( 1700+NB_ )
               ELSE IF( DESCA( RSRC_ ).NE.DESCZ( RSRC_ ) ) THEN
                  INFO = -( 1700+RSRC_ )
               ELSE IF( DESCA( CSRC_ ).NE.DESCZ( CSRC_ ) ) THEN
                  INFO = -( 1700+CSRC_ )
               ELSE IF( ICTXT.NE.DESCZ( CTXT_ ) ) THEN
                  INFO = -( 1700+CTXT_ )
               END IF
         END IF
*
         IF( LOWER ) THEN
            IDUM1( 1 ) = ICHAR( 'L' )
         ELSE
            IDUM1( 1 ) = ICHAR( 'U' )
         END IF
         IDUM2( 1 ) = 1
*
         IF( LQUERY ) THEN
            IDUM1( 2 ) = -1
         ELSE
            IDUM1( 2 ) = 1
         END IF
         IDUM2( 2 ) = 2
            CALL PCHK2MAT( N, 2, N, 2, IA, JA, DESCA, 6, N, 2, N, 2, IZ,
     $                     JZ, DESCZ, 17, 2, IDUM1, IDUM2, INFO )
*
         WORK( 1 ) = DCMPLX( LWOPT )
         RWORK( 1 ) = DBLE( LRWOPT )
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'PZHEEV4', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
* Quick return if possible
*
      IF( QUICKRETURN ) THEN
         NZ = 0
         ICLUSTR( 1 ) =0
         M = 0
         WORK( 1 ) = DCMPLX( LWOPT )
         RWORK( 1 ) = DBLE( LRWMIN )
         IWORK( 1 ) = LIWMIN
         RETURN
      END IF
*
* Scale matrix to allowable range, if necessary.
*
      ABSTLL = ABSTOL
      ISCALE = 0
         VLL = VL
         VUU = VU
*
      ANRM = PZLANHE( 'M', UPLO, N, A, IA, JA, DESCA,
     $       RWORK( INDRWORK ) )
*
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
         ANRM = ANRM*SIGMA
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
         ANRM = ANRM*SIGMA
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PZLASCL( UPLO, ONE, SIGMA, N, N, A, IA, JA, DESCA, IINFO )
*
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
            VLL = VL*SIGMA
            VUU = VU*SIGMA
            IF( VUU.EQ.VLL ) THEN
               VUU = VUU + 2*MAX( ABS( VUU )*EPS, SAFMIN )
            END IF
      END IF
*
* Call PZHENTRD to reduce Hermitian matrix to tridiagonal form.
*
      LALLWORK = LLRWORK
*
      CALL PZHENTRD( UPLO, N, A, IA, JA, DESCA, RWORK( INDD ),
     $               RWORK( INDE ), WORK( INDTAU ), WORK( INDWORK ),
     $               LLWORK, RWORK( INDRWORK ), LLRWORK, IINFO )
*
* Copy the values of D, E to all processes
*
* Here PDLARED1D is used to redistribute the tridiagonal matrix.
* PDLARED1D, however, doesn't yet work with arbritary matrix
* distributions so we have PZELGET as a backup.
*
      OFFSET = 0
      IF( IA.EQ.1 .AND. JA.EQ.1 .AND. RSRC_A.EQ.0 .AND. CSRC_A.EQ.0 )
     $     THEN
         CALL PDLARED1D( N, IA, JA, DESCA, RWORK( INDD ),
     $                   RWORK( INDD2 ), RWORK( INDRWORK ), LLRWORK )
*
         CALL PDLARED1D( N, IA, JA, DESCA, RWORK( INDE ),
     $                   RWORK( INDE2 ), RWORK( INDRWORK ), LLRWORK )
         IF( .NOT.LOWER )
     $      OFFSET = 1
      ELSE
         DO 10 I = 1, N
            CALL PZELGET( 'A', ' ', WORK( INDD2+I-1 ), A, I+IA-1,
     $                    I+JA-1, DESCA )
            RWORK( INDD2+I-1 ) = DBLE( WORK( INDD2+I-1 ) )
   10    CONTINUE
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 20 I = 1, N - 1
               CALL PZELGET( 'A', ' ', WORK( INDE2+I-1 ), A, I+IA-1,
     $                       I+JA, DESCA )
               RWORK( INDE2+I-1 ) = DBLE( WORK( INDE2+I-1 ) )
   20       CONTINUE
         ELSE
            DO 30 I = 1, N - 1
               CALL PZELGET( 'A', ' ', WORK( INDE2+I-1 ), A, I+IA,
     $                       I+JA-1, DESCA )
               RWORK( INDE2+I-1 ) = DBLE( WORK( INDE2+I-1 ) )
   30       CONTINUE
         END IF
      END IF
*
* Call PDSTEBZ and, if eigenvectors are desired, PZSTEIN.
*
         ORDER = 'B'
*
      CALL PDSTEBZ( ICTXT, 'V', ORDER, N, VLL, VUU, 0, 0, ABSTLL,
     $              RWORK( INDD2 ), RWORK( INDE2+OFFSET ), M, NSPLIT, W,
     $              IWORK( INDIBL ), IWORK( INDISP ), RWORK( INDRWORK ),
     $              LLRWORK, IWORK( 1 ), ISIZESTEBZ, IINFO )
*
* IF PDSTEBZ fails, the error propogates to INFO, but
* we do not propogate the eigenvalue(s) which failed because:
* 1)  This should never happen if the user specifies
*     ABSTOL = 2 * PDLAMCH( 'U' )
* 2)  PZSTEIN will confirm/deny whether the eigenvalues are
*     close enough.
*
      IF( IINFO.NE.0 ) THEN
         INFO = INFO + IERREBZ
         DO 40 I = 1, M
            IWORK( INDIBL+I-1 ) = ABS( IWORK( INDIBL+I-1 ) )
   40    CONTINUE
      END IF
*
* Compute the maximum number of eigenvalues that we can
* compute in the
* workspace that we have, and that we can store in Z.
*
* Loop through the possibilities looking for the largest
* NZ that we can feed to PZSTEIN and PZUNMTR
*
* Since all processes must end up with the same value
* of NZ, we first compute the minimum of LALLWORK
*
            CALL IGAMN2D( ICTXT, 'A', ' ', 1, 1, LALLWORK, 1, 1, 1, -1,
     $                    -1, -1 )
*
            MAXEIGS = DESCZ( N_ )
*
            DO 50 NZ = MIN( MAXEIGS, M ), 0, -1
               MQ0 = NUMROC( NZ, NB, 0, 0, NPCOL )
               SIZESTEIN = ICEIL( NZ, NPROCS )*N + MAX( 5*N, NP0*MQ0 )
               SIZEHEEVX = SIZESTEIN
               IF( SIZEHEEVX.LE.LALLWORK )
     $            GO TO 60
   50       CONTINUE
   60       CONTINUE
         NZ = MAX( NZ, 0 )
         IF( NZ.NE.M ) THEN
            INFO = INFO + IERRSPC
*
            DO 70 I = 1, M
               IFAIL( I ) = 0
   70       CONTINUE
*
*     The following code handles a rare special case
*       - NZ .NE. M means that we don't have enough room to store
*         all the vectors.
*       - NSPLIT .GT. 1 means that the matrix split
*     In this case, we cannot simply take the first NZ eigenvalues
*     because PDSTEBZ sorts the eigenvalues by block when
*     a split occurs.  So, we have to make another call to
*     PDSTEBZ with a new upper limit - VUU.
*
            IF( NSPLIT.GT.1 ) THEN
               CALL DLASRT( 'I', M, W, IINFO )
               NZZ = 0
               IF( NZ.GT.0 ) THEN
*
                  VUU = W( NZ ) - TEN*( EPS*ANRM+SAFMIN )
                  IF( VLL.GE.VUU ) THEN
                     NZZ = 0
                  ELSE
                     CALL PDSTEBZ( ICTXT, 'V', ORDER, N, VLL, VUU, 0,
     $                             0, ABSTLL, RWORK( INDD2 ),
     $                             RWORK( INDE2+OFFSET ), NZZ, NSPLIT,
     $                             W, IWORK( INDIBL ), IWORK( INDISP ),
     $                             RWORK( INDRWORK ), LLRWORK,
     $                             IWORK( 1 ), ISIZESTEBZ, IINFO )
                  END IF
*
                  IF( MOD( INFO / IERREBZ, 1 ).EQ.0 ) THEN
                     IF( NZZ.GT.NZ .OR. IINFO.NE.0 ) THEN
                        INFO = INFO + IERREBZ
                     END IF
                  END IF
               END IF
               NZ = MIN( NZ, NZZ )
*
            END IF
         END IF
         CALL PZSTEIN( N, RWORK( INDD2 ), RWORK( INDE2+OFFSET ), NZ, W,
     $                 IWORK( INDIBL ), IWORK( INDISP ), ORFAC, Z, IZ,
     $                 JZ, DESCZ, RWORK( INDRWORK ), LALLWORK,
     $                 IWORK( 1 ), ISIZESTEIN, IFAIL, ICLUSTR, GAP,
     $                 IINFO )
*
         IF( IINFO.GE.NZ+1 )
     $      INFO = INFO + IERRCLS
         IF( MOD( IINFO, NZ+1 ).NE.0 )
     $      INFO = INFO + IERREIN
*
* Z = Q * Z
*
         IF( NZ.GT.0 ) THEN
            CALL PZUNMTR( 'L', UPLO, 'N', N, NZ, A, IA, JA, DESCA,
     $                    WORK( INDTAU ), Z, IZ, JZ, DESCZ,
     $                    WORK( INDWORK ), LLWORK, IINFO )
         END IF
*
* If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( M, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = DCMPLX( LWOPT )
      RWORK( 1 ) = DBLE( LRWOPT )
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
* End of PZHEEV4
*
      END
